/*
Author: Cristhian Alcntara Cadillo
Version: Domino 5.5.5 (Domino 2) May 2000
e-mail: tungra@hotmail.com
icq-number:   51821309
icq-username: tungra
Compiler: JDK 1.1.7
Proved with Windows 98,95,Millenium Edition
All rights reserved
*/



import java.io.*;
import java.net.*;
import java.util.*;

public class ServidorDomino {

ObjectInput in[];
ObjectOutput out[];
Socket sock[];
Inicial inicial[];
ServerSocket server;
int turnos[]; 

public static void main(String args[]) {
	(new ServidorDomino()).initVar();
}

public void initVar(){

 try{       
   Inicial nombres = new Inicial();
   turnos  = new int[4];
   
   server  = new ServerSocket(1442);
   out     = new ObjectOutput[4];
   in      = new ObjectInput[4];
   sock    = new Socket[4];
   inicial = new Inicial[4]; 
   for (int x=0; x<4; x++) inicial[x] = new Inicial();

   reparticionCartas();	 
   for(int x=0; x<4; x++ ) System.out.println("-->"+turnos[x]);
   initChat();   

   for (int x=0; x<4; x++){
      sock[x] = server.accept();
      out[x]  = new ObjectOutputStream (sock[x].getOutputStream());
      in[x]   = new ObjectInputStream  (sock[x].getInputStream());
	System.out.println("Aceptando a jugador nmero "+ (x+1));
   }
  
   for(int x=0; x<4; x++){
	inicial[x].turno=x;
	out[turnos[x]].writeObject(inicial[x]);
	out[turnos[x]].flush();
   }
   for(int x=0; x<4; x++){
		nombres.name[x] = in[turnos[x]].readUTF();
   }  
	
   for(int x=0; x<4; x++){
		out[x].writeObject(nombres);
		out[x].flush();
		
   }
   observarJugadores();
  
 }
 catch(Exception e){System.out.println("Falla inesperada "+e);}
	      
}

public void reparticionCartas(){

	int contador=0;
	int aleatorio;
	int options[] = new int[28];
	int sorted[] = new int[28];
	for(int x=0; x<28; x++){
		options[x]=x;
	}
	
	for(;;){
		aleatorio= (int)(28*Math.random());
		for(int x=0; x<=27; x++){
			if(aleatorio == options[x]){ 
				options[x]=99; 
				sorted[contador]=aleatorio;
				contador++;
				break;
			}
		}
		if(contador==28){break;}
	}	
	contador=0;
	int primero;

	for(int x=0; x<4; x++){
		for(int y=0; y<7; y++){
   		      inicial[x].cartas[y]=sorted[contador];	
			if(sorted[contador]==27){
				primero=x;
				for(int c=0; c<4; c++){
					turnos[c] = primero;
					primero++;
					if(primero>3) primero=0;
				}
			}
			contador++;	
		}
	}

	for(int x=0; x<4; x++){
		System.out.print("jugador "+(x+1)+"o: ");
		for(int y=0; y<7; y++){
			System.out.print(inicial[x].cartas[y]+", ");
		}
		System.out.print("\n");
	}
	System.out.println("");

	Inicial temp[] = new Inicial[4];
	for(int i=0; i<4; i++){
		temp[i] = new Inicial();
		temp[i].copy(inicial[i]); }

	for(int i=0; i<4; i++){
		inicial[i].copy(temp[turnos[i]]);
	}
	for(int x=0; x<4; x++){
		System.out.print("jugador "+(x+1)+"o: ");
		for(int y=0; y<7; y++){
			System.out.print(inicial[x].cartas[y]+", ");
		}
		System.out.print("\n");
	}
}


public void initChat(){
	new InitServer2();
}

public void observarJugadores(){
 Movida temp = new Movida();
 try{
  
  for(;;){

	for(int i=0; i<4; i++){
		temp= (Movida) in[turnos[i]].readObject();
		
		for(int c=0; c<4; c++){
			if(  turnos[c] == turnos[i] ){}
			else{
				out[turnos[c]].writeObject(temp);
				out[turnos[c]].flush();
			}
		}

	}
	
  }
 }catch(Exception e){ 
	System.out.println("Servidor Finalizado..."+e);
	System.exit(1);
 }
}


}

class InitServer2 extends Thread{
	public InitServer2(){start();}
      public void run(){  new Server2();}

}
